/* ----------------------------------------------------------------  */
/* MQSC WebSphereMQ Command Interface                                */
/* ----------------------------------------------------------------  */
parse arg parms
call PrgInit
if qmgrName = 'ALL'
then call QmgrList
else call QmgrState
call PrgEnd
exit

PrgInit:
  hLine = "="~copies(76) || ">"
  if parms~length = 0
  then do
    say ""
    say hLine
    say "QmgrState.rex ===> WebSphereMQ MQSC utility program"
    say "Params       ===> QueueManager"
    say "Usage        ===> rexx QmgrState.rex MQFFM01"
    say "Usage        ===> rexx QmgrState.rex all"
    say hLine
    exit -9999
  end
  else do
    parms = parms~translate
    parse var parms qmgrName .
  end
  logFile = .stream~new("H:\_UK\MQ-Tools\Log\ConnectMon.log")
  logOpen = ''
  do until logOpen = "READY:"
    logOpen = logFile~open
    if logOpen <> "READY:"
    then Call SysSleep 5
  end
  okCount = 0 ; nokCount = 0 ; total = 0
  rcc = rxfuncadd('RXMQINIT','RXMQT','RXMQINIT')
  rcc = RXMQINIT()
  parse var rcc rcInit .
Return

QmgrList:
  qmgrList = .stream~new('QmgrList.cfg')
  rc = qmgrList~open('read')
  if rc <> 'READY:' then exit -9999
  do while qmgrList~lines > 0
    qmgrName = qmgrList~linein
    parse var qmgrName skipQmgr .
    if skipQmgr <> '*'
    then do
      call SetMqvar
      rcc = RXMQCONN(qmgrName)
      parse var rcc rcConn .
      if rcConn <> 0
      then do
        nokCount = nokCount + 1
        atrou = -9
        outString = nokCount~right(4) qmgrName~left(11) "---> RC-NOK  :" rcConn
      end
      else do
        okCount = okCount + 1
        call QueueDepth
        outString = okCount~right(4) qmgrName~left(11) "---> RC-OK   :" rcConn "DLQ = "dlDepth~right(6)", TIC = "tcDepth~right(6)", PAR = "pkDepth~right(6)", MAM = "nsDepth~right(6)
      end
      if atrou <> 0 then say outString
      LogFile~Lineout(outString)
      if rcConn = 0 then rcc = RXMQDISC()
      total = total + 1
    end
  end
  say 'Total =' total '===> ok' okCount '===> failed' nokCount
  qmgrList~close
Return

QmgrState:
  call SetMqvar
  rcc = RXMQCONN(qmgrName)
  parse var rcc rcConn .
  if rcConn <> 0
  then do
    outString = nokCount~right(4) qmgrName~left(11) "---> RCConn :" rcConn
  end
  else do
    outString = okCount~right(4) qmgrName~left(11)  "---> RC-OK  :" rcConn
    call QueueDepth
  end
  say outString
  LogFile~Lineout(outString)
  if rcConn = 0 then rcc = RXMQDISC()
Return

SetMqvar:
  call 'WMQClientConn.rex' qmgrName
  parse var result xFlag qmgrName
Return

QmgrDescr:
  atrin   = MQIA_MAX_MSG_LENGTH
  rcc = RXMQINQ( h1, atrin, 'maxmsg' )
Return

QueueDepth:
  atrou   = 0
  atrin   = mqia_current_q_depth
  dlDepth = 0 ; tcDepth = 0 ; pkDepth = 0 ; nsDepth = 0
  oo      = mqoo_inquire + mqoo_output + mqoo_browse + mqoo_set

  qName = 'SYS.DL.' || qmgrName
  rcc   = RXMQOPEN(qName, oo , 'h2', 'ood.' )
  rcc   = RXMQINQ(h2, atrin, 'dlDepth' )
  rcc   = RXMQCLOS(h2, mqco_none)

  qName = 'LQ.COMI_CACHE_TICKID'
  rcc   = RXMQOPEN(qName, oo , 'h2', 'ood.' )
  rcc   = RXMQINQ(h2, atrin, 'tcDepth' )
  rcc   = RXMQCLOS(h2, mqco_none)

  qName = 'LQ.COMI_CACHE_PARTKRIT'
  rcc   = RXMQOPEN(qName, oo , 'h2', 'ood.' )
  rcc   = RXMQINQ(h2, atrin, 'pkDepth' )
  rcc   = RXMQCLOS(h2, mqco_none)
  
  qName = 'LQ.COMI_CACHE_NAMING_SERVICE'
  rcc   = RXMQOPEN(qName, oo , 'h2', 'ood.' )
  rcc   = RXMQINQ(h2, atrin, 'nsDepth' )
  rcc   = RXMQCLOS(h2, mqco_none)
  atrou = dlDepth + tcDepth + pkDepth + nsDepth
Return

PrgEnd:
  LogFile~close
Return

sayrcc:
  say 'RCC =' rcc
  if RXMQ.LASTRC > 0 then do
    interpret 'lcc = RXMQ.CCMAP.'RXMQ.LASTCC
    interpret 'lac = RXMQ.RCMAP.'RXMQ.LASTAC
    say 'LASTCC =' lcc '; LASTAC =' lac
  end
  do w=1 to words(ood.zlist)
    wrd = word(ood.zlist,w)
    say left('OD.'wrd,15) '<'ood.wrd'>'
  end
  say 'Elapsed time, sec =' time('R')
return
