/* ----------------------------------------------------------------  */
/* Log Channel Status                                                */
/* ig.CQ = "SYSTEM.ADMIN.COMMAND.QUEUE" (default)                    */
/* ig.RQ = "SYSTEM.MQSC.REPLY.QUEUE" (default)                       */
/* ----------------------------------------------------------------  */
parse arg parms
  hLine = "="~copies(76) || ">"
  if parms~length = 0
  then do
    say ""
    say hLine
    say "MqscUtil.rex ===> WebSphereMQ MQSC utility program"
    say "Params       ===> QueueManager"
    say "Usage        ===> rexx MqscUtil.rex MQFFM01"
    say hLine
    exit -2222
  end
  else do
    parms = parms~translate
    parse var parms qmgrName GetQueue PutQueue
  end
  logFile = .stream~new("H:\_UK\MQ-Tools\Log\ChlMon.log")
  logOpen = ''
  do until logOpen = "READY:"
    logOpen = logFile~open
    if logOpen <> "READY:"
    then Call SysSleep 5
  end

-- say '===> Connect to QueueManager'
-- pull qmgrName
ig.QM = qmgrName
rcc = rxfuncadd('RXMQINIT','RXMQT','RXMQINIT')
rcc = RXMQINIT()
parse var rcc rcInit .
call 'WMQClientConn.rex' qmgrName
parse var result zSystem qmgrName

say '===> Your QueueManager is:' ig.QM
-- rc = SysDumpVariables('pp.txt')
ig.TO = 0
do until cmdInp = 'QQ'
  parse upper pull cmdInp
  say ig.QM '===>' cmdInp
  if cmdInp <> '' & cmdInp <> 'QQ'
  then do
--  rc = SysDumpVariables('pp.txt')
    rcc = RXMQC('ig.', cmdInp, 'og.')
--    do j = 1 to words(og.zlist)
--      item = word(og.zlist,j)
--      say item
--      og.item = strip(og.item,'B')
--      say og.item
--    end
--    trace ?i
    do i = 1 to og.0
      og.i = og.i~changestr('0A'x,'')~space
      say og.i
      LogFile~Lineout(og.i)
    end
  end
end
  LogFile~close
Exit

LogAgent:
  logFile = .stream~new("H:\_UK\MQ-Tools\Log\ChlMon.log")
  oldLogData = '' ; newLogData = ''
  chlName = 'SV1510210.MQWIE2'
  mqCmdcur = 'DISPLAY CHSTATUS(SV1510210.MQWIE2) ALL'
  mqCmdsav = 'DISPLAY CHSTATUS(SV1510210.MQWIE2) SAVED'
  do j = 1
    rcc = RXMQC('ig.', mqCmdcur, 'og.')
    cmdident = 'Running '
    TimeStamp = "["date()~right(11) time()"]" chlName "--->"
    do i = 1 to og.0
      parse var og.1 amqmsg .
      if amqmsg = 'AMQ8420:'
      then do
        rcc = RXMQC('ig.', mqCmdsav, 'og.')
        cmdident = 'Sleeping'
      end
      parse var og.i 'CHSTADA('  chdate ')'
      parse var og.i 'CHSTATI('  chtime ')'
      parse var og.i 'CURMSGS('  curmsg ')'
      parse var og.i 'CURSEQNO(' curseq ')'
      parse var og.i 'LSTSEQNO(' lstseq ')'
      parse var og.i 'INDOUBT('  indobt ')'
      parse var og.i 'MCASTAT('  mcasta ')'
      parse var og.i 'MSGS('     msgnum ')'
      if chtime = '' then chtime = '--.--.--'
    end
    newLogData = chtime curseq
    if newLogData <> oldLogData
    then do
      logData = TimeStamp cmdident chtime~changestr('.',':') curseq~right(7) "["j~right(6)"]" 
      call WriteLog
      say logData
      oldLogData = newLogData
    end
    cmdident = 'Running '
    call SysSleep(10)
  end
Return

WriteLog:
  logOpen = ''
  do until logOpen = "READY:"
    logOpen = logFile~open
    if logOpen <> "READY:"
    then Call SysSleep 5
  end
  LogFile~Lineout(logData)
  LogFile~close
Return

/*
--    say '----------------------------------------------'
--    say 'Date            :' chdate
--    say 'Time            :' chtime
--    say 'Current Message :' curmsg
--    say 'Current SeqNum  :' curseq
--    say 'Last SeqNum     :' lstseq
--    say 'Indoubt         :' indobt
--    say 'McaStat         :' mcasta
--    say 'MessageNum      :' msgnum
*/
