/* ------------------------------------------------------------ */
/* RxTrans.rex V001.001 --->                    06.03.2009, und */
/* REXX EBCDIC <---> ASCII Byte Translator                      */
/* ------------------------------------------------------------ */
parse arg inputStr, srcForm, trgForm;

iLe = length(srcForm);
oLe = length(trgForm);
outputStr = '';
ax = '4142434445464748494A4B4C4D4E4F505152535455565758595A'||,
     '6162636465666768696A6B6C6D6E6F707172737475767778797A'||,
     '30313233343536373839E4F6FCC4D6DCDF002021222324252627'||,
  	 '28292A2B2C2D2E2F3A3B3C3D3E3F405B5C5D5E5F607B7C7D7E9BF80D0A';
ex = 'C1C2C3C4C5C6C7C8C9D1D2D3D4D5D6D7D8D9E2E3E4E5E6E7E8E9'||,
     '818283848586878889919293949596979899A2A3A4A5A6A7A8A9'||,
     'F0F1F2F3F4F5F6F7F8F943CCDC63ECFC5900405A7F7B5B6C507D'||,
  	 '4D5D5C4E6B604B617A5E4C7E6E6F7CADE0BD5F6D79C04FD0A14A700D25';

select
  when srcForm = 'E'  then do; iTable = ex; ixConv = 1; end;
  when srcForm = 'EH' then do; iTable = ex; ixConv = 0; end;
  when srcForm = 'A'  then do; iTable = ax; ixConv = 1; end;
  when srcForm = 'AH' then do; iTable = ax; ixConv = 0; end;
  otherwise signal errorExit;
end
select
  when trgForm = 'E'  then do; oTable = ex; oxConv = 1; end;
  when trgForm = 'EH' then do; oTable = ex; oxConv = 0; end;
  when trgForm = 'A'  then do; oTable = ax; oxConv = 1; end;
  when trgForm = 'AH' then do; oTable = ax; oxConv = 0; end;
  otherwise signal errorExit;
end

do i = 1 to length(inputStr) by iLe
  inChar = substr(inputStr, i, iLe);
  if ixConv then inChar = c2x(inChar);
  indexFound = 0;
  index = 0;
  do until indexFound | index = 0
    index = pos(inChar, iTable, index + 1);
    if index > 0 & index // 2 then indexFound = 1;
  end
  if indexFound then do
    outChar = substr(oTable, index, 2);
    if oxConv then outChar = x2c(outChar);
  end
  else  outChar = '?';
  outputStr = outputStr || outChar;
end

return outputStr;          /* called as exec          */
exit 0;
