/* ------------------------------------------------------------ */
/* FileTest V001.001 --->                       20.03.2009, und */
/* ------------------------------------------------------------ */
parse arg what fp prf .

/* ------------------------------------------------------------ */
routine = "" ; i = 0
rcWrite = "n.a"
rcCpy   = "n.a"
rcDel   = "n.a"

if what = 01 then call NewFiles
if what = 02 then call ListFiles
if what = 03 then call CopyFiles
exit                     /* End ------------------------------> */

/* ------------------------------------------------------------ */
/* NewFiles V001.001 --->                                       */
/* ------------------------------------------------------------ */
NewFiles:
  routine = "NewFiles"
  parse value time("L") with hh ":" mm ":" ss "." ms
  FileTime = hh || mm || ss
  FileDate = date("S")~substr(3)
  FilePath = "G:\IBS\IBS\Produkte_Projekte\MQSeries\_MQ-Anwendungen\_Temp\"
  FilePath = "C:\MQ-Tools\Temp\"
  FilePath = "H:\Temp\" || fp || "\"
  if SysFileExists(FilePath) = 0 then rc = SysMkDir("H:\Temp\" || fp)
  fileSuff = ".dat"
  if prf = "" 
  then filePref = "MZ" || FileDate
  else filePref = prf || FileDate
  fileCount = 1000000

  do i = 1
    fileCount = fileCount + 1
    if fileCount // 1000 = 0 then say "====>" time() fileCount
    outString = fileCount random(fileCount)
    /* outString = outString~copies(8192) */
    OutFile   = FilePref || fileCount || fileSuff
    OutStream = .stream~new(FilePath || OutFile)
    rcWrite = OutStream~lineout(outString)
    OutStream~close
    if rcWrite <> 0 then call ExitErrors
  end
return

ListFiles:
/* ------------------------------------------------------------ */
/* ListFiles V001.001 --->                                      */
/* ------------------------------------------------------------ */
  routine = "ListFiles"
  file_spec   = "*.*"
  inp_path    = "C:\MQ-Tools\Temp\"
-- call sysfiletree inp_path || file_spec, 'file', FO
  call sysfiletree inp_path || file_spec, 'file', BS
  say "===>" file.0

  do i = 1 to file.0
    in_file      = file.i
    in_file_name = in_file~substr(in_file~lastpos("\") + 1)
    in_file_path = in_file~substr(1,in_file~lastpos("\"))
    if in_file_name~lastpos(".") > 0
    then in_file_noex = in_file_name~substr(1,in_file_name~lastpos(".") - 1)
    else in_file_noex = in_file_name
  end
return

CopyFiles:
/* ------------------------------------------------------------ */
/* CopyFiles V001.001 --->                                      */
/* ------------------------------------------------------------ */
  routine   = "CopyFiles"
  file_spec = "*.*"
  inp_path  = "C:\MQ-Tools\Temp\"
  out_path  = "C:\MQ-Tools\Temp\t1\"
  inp_path  = "H:\Temp\"
  out_path  = "H:\Temp\t1\"
  call sysfiletree inp_path || file_spec, 'file', FO
  say "====>" file.0

  do i = 1 to file.0
    if i // 1000 = 0 then say "====>" time() i
    in_file      = file.i
    in_file_name = in_file~substr(in_file~lastpos("\") + 1)
    in_file_path = in_file~substr(1,in_file~lastpos("\"))
    if in_file_name~lastpos(".") > 0
    then in_file_noex = in_file_name~substr(1,in_file_name~lastpos(".") - 1)
    else in_file_noex = in_file_name
    outFile = out_path || in_file_name               /* ~left() */
    rcCpy = SysFileCopy(in_file, outFile)
    rcDel = SysFileDelete(in_file)
    if rcCpy | rcDel <> 0 then call ExitErrors
  end
return

ExitErrors:
/* ------------------------------------------------------------ */
/* ExitErrors V001.001 --->                                     */
/* ------------------------------------------------------------ */
say "---------------------------"
say "Routine :" routine
say "Count   :" i
say "WriteRC :" rcWrite
say "CopyRC  :" rcCpy
say "DelRC   :" rcDel
say "---------------------------"
say "Hit Enter to Terminate"
pull .
exit
return
