/* ------------------------------------------------------------ */
/* MqGen.rex                      V001.001 ---> 04.12.2013, und */
/* ------------------------------------------------------------ */
parse arg inpPath
-- trace ?i
call ProgInit
call FileTree
exit
/* ------------------------------------------------------------ */

ProgInit:
  startTime = time()
  eTime = time("E")
  inpPathLen = inpPath~length
  fByte = inpPath~substr(1,1)~c2x
  lByte = inpPath~substr(inpPathLen)~c2x
  if fByte = "22" & lByte = "22"
  then do
    filePath = inpPath~substr(2,inpPathLen - 2)
    inpPath = inpPath~substr(2,inpPathLen - 2) || "\"
  end
  else do
    filePath = inpPath
    inpPath = inpPath || "\"
  end
  fileSpec   = "*.mqc"
  inpPath = inpPath || fileSpec
  k = 0
  hitCount = 0
  stringTab = "MQ001T"
  fSizeLimit = 1000000
  
  errFile = .stream~new("H:\_UK\MQ-Tools\Output\FndErr.log")
  rcErr = errFile~open('write')
  if rcErr = "READY:"
  then do
  end
  fndFile = .stream~new("H:\_UK\MQ-Tools\Output\FndList.log")
  rcFnd = fndFile~open('write')
  if rcFnd = "READY:"
  then do
  end
return

FileTree:
  call sysfiletree inpPath, 'file', FS
  -- call sysfiletree filePath, 'dirList', 'DS'
  
  
  numberOfFiles = file.0
  eTime = time("E")
  say "====>" startTime "====>" eTime "["numberOfFiles"]"
  percent = numberOfFiles / 100 * 10
  percent = percent~format(,0)
  do i = 1 to numberOfFiles
    parse var file.i fDate fTime fSize fAttr fPath
    fByte = fPath~substr(1,1)~c2x
    if fByte = "20" then fPath = fPath~substr(2)
    fileExt = fPath~substr(fPath~lastpos(".") + 1)
    dotPos = fPath~lastpos(".")
    -- if dotPos < 24 | fileExt = "zip" | fileExt = "exe" then iterate
    if fileExt = "zip" | fileExt = "exe" then iterate
    if fSize < fSizeLimit
    then do
    end
    MsgBuffer = "" ; inFile =  ""
    inFile = .stream~new(fPath)
    rcInp = inFile~open('read')
    if rcInp = "READY:"
    then do
      BufferLength = inFile~chars
      MsgBuffer = inFile~charin(,BufferLength)
      MsgBuffer = MsgBuffer~translate
      rcInp = inFile~close
      do j = 1 to stringTab~words
        fString = stringTab~word(j)
        if MsgBuffer~pos(fString) > 0
        then do
          hitCount = hitCount + 1
          fndFile~lineout(fstring "===>" fPath)
        end
      end
    end
    else do
      errFile~lineout("=>>>>" rcInp "Error open file --->" fPath)
    end
    if i // percent = 0
    then do
      k = k + 10
      say "====>" k~right(3) || "% ====> Hits [" || hitCount || "]"
    end
    file.i = ""
  end
  if k < 100 then say "====> 100% ====> Hits [" hitCount || "]"
  rTime = time("R")
  say "<====" Time() "====>" rTime
  say "<====" Time() "====> END"
  pull .
return


QREMOTE('RQ.PRIMEGATE.ISSUER.DE0001')
   RQMNAME('SV2207570')
   XMITQ('SYS.TQ.SV2207585.SV2207570')
QLOCAL('SYS.TQ.SV2207585.SV2207570')
   INITQ('SYSTEM.CHANNEL.INITQ')
   TRIGGER
   TRIGDATA('SV2207585.SV2207570')
   USAGE(XMITQ)
DEFINE CHANNEL('SV2207585.SV2207570') CHLTYPE(SDR)
   CONNAME('mqsrsi14.zit.commerzbank.com(1414)')
   LOCLADDR('mqsrsi15.zit.commerzbank.com')
   MCAUSER(' ')
   XMITQ('SYS.TQ.SV2207585.SV2207570')
DEFINE CHANNEL('SV2207570.SV2207585') CHLTYPE(RCVR)
   MCAUSER(' ')
   SCYDATA('FN=/var/mqm/exits64/08-05-27.BI;')




DEFINE QREMOTE('RQ.PRIMEGATE.ISSUER.DE0001')
   DESCR('Remote Queue to iCom Trading 08-05-27')
   RQMNAME('SV2207570')
   RNAME('LQ.ICOM.BROKER.PRIMEGATE')
   XMITQ('SYS.TQ.SV2207585.SV2207570')
   REPLACE
DEFINE QLOCAL('SYS.TQ.SV2207585.SV2207570')
   DESCR('Transmit Queue to iCom Trading 08-05-27')
   INITQ('SYSTEM.CHANNEL.INITQ')
   TRIGGER
   TRIGDATA('SV2207585.SV2207570')
   USAGE(XMITQ)
   REPLACE
DEFINE CHANNEL('SV2207585.SV2207570') CHLTYPE(SDR)
   DESCR('Sender Channel to iCom Trading 08-05-27')
   CONNAME('mqsrsi14.zit.commerzbank.com(1414)')
   LOCLADDR('mqsrsi15.zit.commerzbank.com')
   MCAUSER(' ')
   XMITQ('SYS.TQ.SV2207585.SV2207570')
   REPLACE
DEFINE CHANNEL('SV2207570.SV2207585') CHLTYPE(RCVR)
   DESCR('Receiver Channel from iCom Trading 08-05-27')
   MCAUSER(' ')
   SCYDATA('FN=/var/mqm/exits64/08-05-27.BI;')
   SCYEXIT('BlockIP2(BlockExit)')
   TRPTYPE(TCP)
   REPLACE

